#include "stm8s.h"
#include "vgm.h"

int main(void) {

	// Initialise the clock to have a /1 prescaler and use the external crystal clock source for accuracy.
	CLK_DeInit();
	CLK_SYSCLKConfig(CLK_PRESCALER_CPUDIV1);
	CLK_ClockSwitchConfig(CLK_SWITCHMODE_AUTO, CLK_SOURCE_HSE, DISABLE, CLK_CURRENTCLOCKSTATE_DISABLE);

	// Use TIM2 to generate the two audio output channels using PWM.
	TIM2_DeInit();
	TIM2_TimeBaseInit(TIM2_PRESCALER_1, (u16)(4 * 15 - 1));
	TIM2_OC1Init(TIM2_OCMODE_PWM2, TIM2_OUTPUTSTATE_ENABLE, (u16)(4 * 15), TIM2_OCPOLARITY_LOW);
	TIM2_OC2Init(TIM2_OCMODE_PWM2, TIM2_OUTPUTSTATE_ENABLE, (u16)(4 * 15), TIM2_OCPOLARITY_LOW);
	TIM2_Cmd(ENABLE);
	
	// Use TIM3 to periodically generate new samples via an interrupt handler.
	TIM3_DeInit();
	// (16000000/44100)-1 = ~361
	TIM3_TimeBaseInit(TIM3_PRESCALER_1, (u16)(361));
	TIM3_ITConfig(TIM3_IT_UPDATE, ENABLE);
	TIM3_Cmd(ENABLE);
	
	// Finally, enable interrupts to get everything going.
	enableInterrupts();	
	
	VGM_Load();
	for(;;) {
		VGM_Update();			
	}
	
}