#ifndef VGM_H
#define VGM_H

// Address of the version field.
#define VGM_HEADER_VERSION (0x08)

// Address of the SN76489's clock rate field.
#define VGM_HEADER_SN76489_CLOCK (0x0C)

// Address of the loop offset field.
#define VGM_HEADER_LOOP_OFFSET (0x1C)

// Address of the feedback/"tapped bits" field.
#define VGM_HEADER_SN76489_FEEDBACK (0x28)

// Address of the shift register width field.
#define VGM_HEADER_SN76489_SHIFT_REGISTER_WIDTH (0x2A)

// Loads the VGM file.
void VGM_Load(void);

// Fetches data from the VGM and uses it to update the PSG; should be called on a loop.
void VGM_Update(void);

#endif